SystemOrganization addCategory: #'Xpf-AdminTool'!

SwaDialog subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry userLoginEntry saveProjectButton saveUserButton projectAddButton userAddButton projectDeleteButton userDeleteButton userPasswordButton projectDeveloperList projectUserDropList projectAddDeveloperButton projectDeleteDeveloperButton widgetStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-AdminTool'!

!XpfAdminTool class methodsFor: 'user interface' stamp: 'mt 4/4/2010 12:03:16'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 12:35:25'!
createNavigationProjectsButton

	^ (SwaToolButton
		icon: MenuIcons flagBlueIcon
		label: 'Projects'
		receiver: widgetStack
		selector: #currentIndex:)
		arguments: {1}! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 12:35:31'!
createNavigationUsersButton

	^ (SwaToolButton
		icon: MenuIcons xpfUser
		label: 'Users'
		receiver: widgetStack
		selector: #currentIndex:)
		arguments: {2}! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:36:06'!
createProjectAddButtonFor: myModel 

	self projectAddButton: (SwaPushButton
		label: 'Add Project'
		receiver: myModel
		selector: #addProject
		help: 'Add new project').
	^ self projectAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:37:31'!
createProjectAddDeveloperButtonFor: myModel 

	self projectAddDeveloperButton: (SwaPushButton
		label: 'Add'
		receiver: myModel
		selector: #addDeveloperToProject
		"getEnabled: #hasCurrentProjectCandidateIndex"
		help: 'Add the candidate as developer to this project.').
	^ self projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:38:52'!
createProjectDeleteButtonFor: myModel 

	self projectDeleteButton: (SwaPushButton 
		label: 'Delete Project'
		receiver: myModel
		selector: #deleteProject
		"getEnabled: #hasProjects"
		help: 'Delete project').
	^ self projectDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:39:22'!
createProjectDeleteDeveloperButtonFor: myModel 

	self projectDeleteDeveloperButton: (SwaPushButton
		label: 'Remove'
		receiver: myModel
		selector: #deleteDeveloper
		"getEnabled: #hasCurrentProjectDeveloperIndex"
		help: 'Remove the selected developer from the current project. The user remains in the database.').
	^ self projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:01:25'!
createProjectDeveloperListFor: aModel

	self projectDeveloperList: (SwaListView
		for: aModel
		list: #allProjectDeveloperNames
		selected: #currentProjectDeveloperIndex
		changeSelected: #currentProjectDeveloperIndex:
		help: 'Shows all developers of this project.').
	^ self projectDeveloperList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:01:51'!
createProjectListFor: aModel

	self projectList: (SwaListView
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		help: 'Shows all projects.').
	^ self projectList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 17:39:44'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: (SwaLineEdit
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
"		class: String
		getEnabled: #hasCurrentProject"
		help: 'Enter a short descriptive title for this project.').
	^ self projectTitleEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:58:45'!
createProjectUserDropListFor: aModel

	self projectUserDropList: ((SwaComboBox
		on: aModel
		list: #allProjectCandidateNames
		selected: #currentProjectCandidateIndex
		changeSelected: #currentProjectCandidateIndex:
		"getEnabled: #hasCurrentProjectCandidates"
		useIndex: true)
		setBalloonText: 'All available users for this project').
	^ self projectUserDropList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:39'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButton}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Developers:'.
			self createHFiller.
			self createProjectDeleteDeveloperButtonFor: myModel}.
		self createProjectDeveloperListFor: myModel.
		self createRow: {
			self createLabel: 'Candidate:'. 
			self createProjectUserDropListFor: myModel. 
			self createProjectAddDeveloperButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createProjectListFor: myModel. 
			self createRow: {
				self createProjectAddButtonFor: myModel. 
				self createProjectDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:42:46'!
createQuitButton

	^ SwaPushButton
		label: 'Quit'
		receiver: self
		selector: #cancel
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:43:20'!
createSaveProjectButton

	self saveProjectButton: (SwaPushButton
		label: 'Save'
		receiver: self projectTitleEntry
		selector: #accept
		"getEnabled: #enabled"
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:44:13'!
createSaveUserButtonFor: myModel

	self saveUserButton: ((SwaPushButton
		label: 'Save'
		receiver: myModel
		selector: #updateUser:
		"getEnabled: #hasCurrentUser"
		help: 'Save changed user data')
		arguments: {{self userNameEntry. self userLoginEntry}}).
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:44:51'!
createUserAddButtonFor: myModel 

	self userAddButton: (SwaPushButton
		label: 'Add User'
		receiver: myModel
		selector: #addUser
		help: 'Add new user').
	^ self userAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:45:25'!
createUserDeleteButtonFor: myModel 

	self userDeleteButton: (SwaPushButton
		label: 'Delete User'
		receiver: myModel
		selector: #deleteUser
		"getEnabled: #hasUsers"
		help: 'Delete User').
	^ self userDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:02:04'!
createUserListFor: aModel

	self userList: (SwaListView
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		help: 'Shows all users.').
	^ self userList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 17:44:41'!
createUserLoginEntryFor: myModel

	self userLoginEntry: (SwaLineEdit
		for: myModel
		get: #currentUserLogin
		set: #currentUserLogin:
"		class: String
		getEnabled: #hasCurrentUser"
		help: 'Enter a valid email address').
	^ self userLoginEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 17:45:02'!
createUserNameEntryFor: myModel

	self userNameEntry: (SwaLineEdit
		for: myModel
		get: #currentUserName
		set: #currentUserName:
"		class: String
		getEnabled: #hasCurrentUser"
		help: 'Enter the name of the user.').
	^ self userNameEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 4/5/2010 14:46:13'!
createUserPasswordButtonFor: myModel 

	self userPasswordButton: ((SwaPushButton
		label: 'Change Password...'
		receiver: myModel
		selector: #changePassword:
		"getEnabled: #hasCurrentUser"
		help: 'Change the current password')
		arguments: {self}).
	^ self userPasswordButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:36'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {
			self createLabel: 'Name:'. 
			self createUserNameEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Login/E-Mail:'. 
			self createUserLoginEntryFor: myModel}.
		self createRow: {
			self createUserPasswordButtonFor: myModel.
			self createHFiller. 
			self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createUserListFor: myModel. 
			self createRow: {
				self createUserAddButtonFor: myModel. 
				self createUserDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'submorphs-add/remove' stamp: 'cs 6/3/2009 15:54'!
delete

	self model repository isRestProxy ifTrue: [
		self model repository stopUpdating].
	super delete.! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 4/5/2010 14:10:50'!
initializeUserInterface: myModel

	| navigation btns |
	widgetStack := SwaStackedWidget new.
	btns := {
		self createNavigationProjectsButton.
		self createNavigationUsersButton}.
		
	navigation := SwaToolButton
		buttonGroupFor: btns
		orientation: #horizontal.
	
	btns first setChecked: true.
	
	widgetStack
		addWidget: (self createProjectsTabFor: myModel);
		addWidget: (self createUsersTabFor: myModel).
		
	^ self createCol: {navigation. widgetStack}
"	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}"! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'cs 6/3/2009 15:52'!
initializeWith: aRepository 

	| myModel |
	myModel := XpfAdminToolModel newWithRepository: aRepository.
	self
		buttons: {  (self createQuitButton)};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'.
	aRepository isRestProxy ifTrue: [aRepository startUpdating].! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton
	^ projectAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton: anObject
	projectAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton
	^ projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton: anObject
	projectAddDeveloperButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton
	^ projectDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton: anObject
	projectDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:25'!
projectDeleteDeveloperButton
	
	^ projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:24'!
projectDeleteDeveloperButton: anObject

	projectDeleteDeveloperButton := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList
	^ projectDeveloperList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList: anObject
	projectDeveloperList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList
	^ projectUserDropList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList: anObject
	projectUserDropList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton
	^ userAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton: anObject
	userAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton
	^ userDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton: anObject
	userDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry
	^ userLoginEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry: anObject
	userLoginEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton
	^ userPasswordButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton: anObject
	userPasswordButton := anObject! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'projects currentProjectIndex users currentUserIndex currentProjectCandidateIndex currentProjectDeveloperIndex reposistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-AdminTool'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/16/2009 11:29'!
newWithRepository: aRepository

	^ self new repository: aRepository! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 4/16/2009 17:20'!
addDeveloperToProject

	self currentProject developers add: 
		(self currentProjectCandidates at: self currentProjectCandidateIndex).
			
	self currentProjectCandidateIndex: 0.
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
addProject
	| newProject |
	newProject := reposistory 
				addProject: (Dictionary newFrom: {  ('title' -> 'New Project')}).
	projects := nil.
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self indexOfProject: newProject);
		changed: #hasCurrentProject! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
addUser
	| newUser |
	newUser := reposistory 
				addUser: (Dictionary newFrom: { 
								('userName' -> 'New User').
								('login' -> 'new.user@email.de').
								('password' -> nil)}).
	users := nil.
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self indexOfUser: newUser);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:50'!
allProjectCandidateNames

	^ self currentProjectCandidates collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
allProjectDeveloperNames

	^ self currentProjectDevelopers collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:20'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 4/5/2010 20:19:25'!
changePassword: aDialog

	| newPassword |
	newPassword := SwaInputDialog
		getTextWithTitle: 'Change Password'
		label: ('Enter new password for ''{1}''' format: {self currentUserName}).
				
	newPassword ifNil: [^ self].
	
	self currentUserPassword: newPassword! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:36'!
currentProject

	^ self projects at: self currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectCandidateIndex

	^ currentProjectCandidateIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:38'!
currentProjectCandidateIndex: anObject

	currentProjectCandidateIndex := anObject.
	self
		changed: #currentProjectCandidateIndex;
		changed: #hasCurrentProjectCandidateIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectCandidates

	self hasCurrentProject ifFalse: [^ #()].
	
	^ self users reject: [:user | 
		self currentProject developers anySatisfy: [:dev | dev id = user id]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectDeveloperIndex

	^ currentProjectDeveloperIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:45'!
currentProjectDeveloperIndex: anObject

	currentProjectDeveloperIndex := anObject.
	self changed: #currentProjectDeveloperIndex.
	self changed: #hasCurrentProjectDeveloperIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectDevelopers

	self hasCurrentProject ifFalse: [^ #()].
	^ self currentProject developers ! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:34'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #hasCurrentProject;
		changed: #currentProjectIndex;
		changed: #currentProjectTitle;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:22'!
currentProjectTitle

	^ self hasCurrentProject
		ifTrue: [self allProjectTitles at: self currentProjectIndex]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:50'!
currentProjectTitle: aString

	self currentProject title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 15:37'!
currentUser

	^ self users at: self currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:34'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #hasCurrentUser;
		changed: #currentUserIndex;
		changed: #currentUserName;
		changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:04'!
currentUserLogin

	^ self hasCurrentUser
		ifTrue: [self currentUser login]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 6/3/2009 15:56'!
currentUserLogin: aString

	| oldLogin |
	oldLogin := (self users at: self currentUserIndex) login.
	(self users at: self currentUserIndex) login: aString.
	(self repository isRestProxy and: [self repository login = oldLogin])
		ifTrue: [self repository login: aString].
	self changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/12/2009 12:34'!
currentUserName: aString

	self currentUser userName: aString.
	
	self flag: #temporary. projects := nil.
	
	self
		changed: #currentUserName;
		changed: #allUserNames;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:58'!
currentUserPassword: aString

	(self users at: self currentUserIndex) password: aString.
	self repository login = self currentUserLogin
		ifTrue: [self repository password: aString].
	self changed: #currentUserPassword.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 3/9/2009 15:42'!
deleteDeveloper

	self currentProject developers remove: 
		(self currentProjectDevelopers at: self currentProjectDeveloperIndex).
			
	self currentProjectDeveloperIndex: (self currentProjectDeveloperIndex > self currentProject developers size 
			ifTrue: [self currentProject developers size] 
			ifFalse: [self currentProjectDeveloperIndex]).
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:00'!
deleteProject

	self currentProject delete.
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self currentProjectIndex > self projects size 
			ifTrue: [self projects size] 
			ifFalse: [self currentProjectIndex]);
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:01'!
deleteUser

	self currentUser delete.
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self currentUserIndex > self users size 
			ifTrue: [self users size] 
			ifFalse: [self currentUserIndex]);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:35'!
hasCurrentProject

	^ self currentProjectIndex notNil and: 
		[(self currentProjectIndex > 0) & (self currentProjectIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/12/2009 10:50'!
hasCurrentProjectCandidateIndex

	^ self currentProjectCandidateIndex notNil and: 
		[(self currentProjectCandidateIndex > 0) & (self currentProjectCandidateIndex <= self currentProjectCandidates size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectCandidates

	^ self currentProjectCandidates isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:01'!
hasCurrentProjectDeveloperIndex

	^ self hasCurrentProject and:
		[self currentProjectDeveloperIndex notNil and: 
		[(self currentProjectDeveloperIndex > 0) &
		(self currentProjectDeveloperIndex <= self currentProject developers size)]]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectDevelopers

	^ self currentProjectDevelopers isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 13:49'!
hasCurrentUser

	^ self currentUserIndex notNil and: 
		[(self currentUserIndex > 0) & (self currentUserIndex <= self users size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 14:05'!
hasProjects

	^ self projects isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 14:05'!
hasUsers

	^ self users isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:30'!
indexOfProject: aProject
	"returns the index of the specified project in the displayed list of projects"

	^ self projects indexOf: (self projects detect: [:each | each id = aProject id])! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:28'!
indexOfUser: aUser
	"returns the index of the specified user in the displayed list of users"

	^ self users indexOf: (self users detect: [:each | each id = aUser id])! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 16:20'!
initialize

	super initialize.
	self
		currentProjectIndex: 0;
		currentUserIndex: 0;
		currentProjectCandidateIndex: 0;
		currentProjectDeveloperIndex: 0.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 6/3/2009 15:50'!
projects

	^ projects ifNil: 
		[projects := reposistory projects asOrderedCollection
			sortBy: [:first :second | first title < second title]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository

	^ reposistory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository: anObject

	reposistory := anObject.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 6/3/2009 16:00'!
updateUser: someEntries 

	self currentUser deferCommit: [
		someEntries	do: [:entry | entry accept]].! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 6/3/2009 15:52'!
users

	^ users ifNil: 
		[users := reposistory users asOrderedCollection
			sortBy: [:first :second | first userName < second userName]]! !
